// Code generated by smithy-go-codegen DO NOT EDIT.

// Package health provides the API client, operations, and parameter types for AWS
// Health APIs and Notifications.
//
// AWS Health The AWS Health API provides programmatic access to the AWS Health
// information that appears in the AWS Personal Health Dashboard
// (https://phd.aws.amazon.com/phd/home#/). You can use the API operations to get
// information about AWS Health events that affect your AWS services and
// resources.
//
// * You must have a Business or Enterprise Support plan from AWS
// Support (http://aws.amazon.com/premiumsupport/) to use the AWS Health API. If
// you call the AWS Health API from an AWS account that doesn't have a Business or
// Enterprise Support plan, you receive a SubscriptionRequiredException error.
//
// *
// You can use the AWS Health endpoint health.us-east-1.amazonaws.com (HTTPS) to
// call the AWS Health API operations. AWS Health supports a multi-Region
// application architecture and has two regional endpoints in an active-passive
// configuration. You can use the high availability endpoint example to determine
// which AWS Region is active, so that you can get the latest information from the
// API. For more information, see Accessing the AWS Health API
// (https://docs.aws.amazon.com/health/latest/ug/health-api.html) in the AWS Health
// User Guide.
//
// For authentication of requests, AWS Health uses the Signature
// Version 4 Signing Process
// (https://docs.aws.amazon.com/general/latest/gr/signature-version-4.html). If
// your AWS account is part of AWS Organizations, you can use the AWS Health
// organizational view feature. This feature provides a centralized view of AWS
// Health events across all accounts in your organization. You can aggregate AWS
// Health events in real time to identify accounts in your organization that are
// affected by an operational event or get notified of security vulnerabilities.
// Use the organizational view API operations to enable this feature and return
// event information. For more information, see Aggregating AWS Health events
// (https://docs.aws.amazon.com/health/latest/ug/aggregate-events.html) in the AWS
// Health User Guide. When you use the AWS Health API operations to return AWS
// Health events, see the following recommendations:
//
// * Use the eventScopeCode
// (https://docs.aws.amazon.com/health/latest/APIReference/API_Event.html#AWSHealth-Type-Event-eventScopeCode)
// parameter to specify whether to return AWS Health events that are public or
// account-specific.
//
// * Use pagination to view all events from the response. For
// example, if you call the DescribeEventsForOrganization operation to get all
// events in your organization, you might receive several page results. Specify the
// nextToken in the next request to return more results.
package health
