// Code generated by smithy-go-codegen DO NOT EDIT.

package types

import (
	smithydocument "github.com/aws/smithy-go/document"
	"time"
)

// Lists all the devices under test
type DeviceUnderTest struct {

	// Lists devices certificate arn
	CertificateArn *string

	// Lists devices thing arn
	ThingArn *string

	noSmithyDocumentSerde
}

// Show Group Result.
type GroupResult struct {

	// Group result Id.
	GroupId *string

	// Group Result Name.
	GroupName *string

	// Tests under Group Result.
	Tests []TestCaseRun

	noSmithyDocumentSerde
}

// Gets Suite Definition Configuration.
type SuiteDefinitionConfiguration struct {

	// Gets device permission arn.
	DevicePermissionRoleArn *string

	// Gets the devices configured.
	Devices []DeviceUnderTest

	// Gets the tests intended for qualification in a suite.
	IntendedForQualification bool

	// Gets test suite root group.
	RootGroup *string

	// Gets Suite Definition Configuration name.
	SuiteDefinitionName *string

	noSmithyDocumentSerde
}

// Information about the suite definition.
type SuiteDefinitionInformation struct {

	// Date (in Unix epoch time) when the test suite was created.
	CreatedAt *time.Time

	// Specifies the devices under test for the test suite.
	DefaultDevices []DeviceUnderTest

	// Specifies if the test suite is intended for qualification.
	IntendedForQualification bool

	// Suite definition Id of the test suite.
	SuiteDefinitionId *string

	// Suite name of the test suite.
	SuiteDefinitionName *string

	noSmithyDocumentSerde
}

// Gets suite run configuration.
type SuiteRunConfiguration struct {

	// Gets the primary device for suite run.
	PrimaryDevice *DeviceUnderTest

	// Gets test case list.
	SelectedTestList []string

	noSmithyDocumentSerde
}

// Information about the suite run.
type SuiteRunInformation struct {

	// Date (in Unix epoch time) when the suite run was created.
	CreatedAt *time.Time

	// Date (in Unix epoch time) when the suite run ended.
	EndAt *time.Time

	// Number of test cases that failed in the suite run.
	Failed int32

	// Number of test cases that passed in the suite run.
	Passed int32

	// Date (in Unix epoch time) when the suite run was started.
	StartedAt *time.Time

	// Status of the suite run.
	Status SuiteRunStatus

	// Suite definition Id of the suite run.
	SuiteDefinitionId *string

	// Suite definition name of the suite run.
	SuiteDefinitionName *string

	// Suite definition version of the suite run.
	SuiteDefinitionVersion *string

	// Suite run Id of the suite run.
	SuiteRunId *string

	noSmithyDocumentSerde
}

// Provides test case run.
type TestCaseRun struct {

	// Provides test case run end time.
	EndTime *time.Time

	// Provides test case run failure result.
	Failure *string

	// Provides test case run log Url.
	LogUrl *string

	// Provides test case run start time.
	StartTime *time.Time

	// Provides test case run status.
	Status Status

	// Provides test case run definition Id.
	TestCaseDefinitionId *string

	// Provides test case run definition Name.
	TestCaseDefinitionName *string

	// Provides test case run Id.
	TestCaseRunId *string

	// Provides test case run warnings.
	Warnings *string

	noSmithyDocumentSerde
}

// Show each group result.
type TestResult struct {

	// Show each group of test results.
	Groups []GroupResult

	noSmithyDocumentSerde
}

type noSmithyDocumentSerde = smithydocument.NoSerde
